package driver;

import java.util.*;

import jist.runtime.JistAPI;
import jist.swans.Constants;
import jist.swans.app.AppJava;
import jist.swans.field.Field;
import jist.swans.field.Gps;
import jist.swans.loc.LocationGod;
import jist.swans.loc.LocationServiceInterface;
import jist.swans.mac.Mac802_11;
import jist.swans.mac.MacAddress;
import jist.swans.misc.Location;
import jist.swans.misc.Mapper;
import jist.swans.misc.Util;
import jist.swans.net.NetAddress;
import jist.swans.net.NetIp;
import jist.swans.net.PacketLoss;
import jist.swans.radio.RadioInfo;
import jist.swans.radio.RadioNoise;
import jist.swans.radio.RadioNoiseIndep;
import jist.swans.route.Cluster;
import jist.swans.route.RouteMFR;
import jist.swans.trans.TransUdp;
import driver.mfrtest.Client;
import driver.mfrtest.Server;

public class TestCluster {

	  static Field field = new Field(new Location.Location2D(2500, 2500));

	 static  HashSet clusters;
	  
	  
	  private static NetIp CreateNode(int id,RadioInfo.RadioInfoShared radioInfoShared,Mapper protMap,Field field,PacketLoss pl,Location pos){
	      RadioNoise radio = new RadioNoiseIndep(id, radioInfoShared);

	      
	      // mac
	      Mac802_11 mac = new Mac802_11(new MacAddress(id), radio.getRadioInfo());
	      // net
	      NetIp net = new NetIp(new NetAddress(id), protMap, pl, pl);

	      

	      // route
	      Cluster route = new Cluster(net.getAddress());
	      clusters.add(route);

	      
	      field.addRadio(radio.getRadioInfo(), radio.getProxy(), pos);
	     
	      // radio hookup
	      radio.setFieldEntity(field.getProxy());
	      radio.setMacEntity(mac.getProxy());
	      
	      // route hookup
	      route.setNetEntity(net.getProxy());

	      
	      // net hookup
	      byte intId = net.addInterface(mac.getProxy());

	      
	      net.setProtocolHandler(Constants.NET_PROTOCOL_CLUSTER, route.getProxy());  
	      
	      net.setRouting(route.getProxy());

	      // mac hookup
	      mac.setRadioEntity(radio.getProxy());

	      
	      mac.setNetEntity(net.getProxy(), intId);

 	      

		  return net;
	  }
	  
	  private static void TwoNodeTest()
	  {
	   try
	    {
	      // field
	      //Location bounds = new Location.Location2D(200, 2500);
	      
		   clusters = new HashSet();
	      
	      RadioInfo.RadioInfoShared radioInfoShared = RadioInfo.createShared(
	          Constants.FREQUENCY_DEFAULT, 
	          Constants.BANDWIDTH_DEFAULT,
	          Constants.TRANSMIT_DEFAULT, 
	          Constants.GAIN_DEFAULT,
	          Util.fromDB(Constants.SENSITIVITY_DEFAULT), 
	          Util.fromDB(Constants.THRESHOLD_DEFAULT),
	          Constants.TEMPERATURE_DEFAULT, 
	          Constants.TEMPERATURE_FACTOR_DEFAULT, 
	          Constants.AMBIENT_NOISE_DEFAULT);
	      

	      // protocol mapper
	      Mapper protMap = new Mapper(Constants.NET_PROTOCOL_MAX);
	      protMap.mapToNext(Constants.NET_PROTOCOL_CLUSTER);
	      // packet loss
	      PacketLoss pl = new PacketLoss.Zero();
	      // nodes
	      int i=1;
	      // radio
	      
	      
	      NetIp net1=CreateNode(1,radioInfoShared,protMap,field,pl,new Location.Location2D(0,0));
	      NetIp net2=CreateNode(2,radioInfoShared,protMap,field,pl,new Location.Location2D(400,0));
	      NetIp net3=CreateNode(3,radioInfoShared,protMap,field,pl,new Location.Location2D(800,0));
	      NetIp net4=CreateNode(4,radioInfoShared,protMap,field,pl,new Location.Location2D(1200,0));
	      CreateNode(5,radioInfoShared,protMap,field,pl,new Location.Location2D(1600,0));
 	      CreateNode(6,radioInfoShared,protMap,field,pl,new Location.Location2D(2000,0));
 	      CreateNode(7,radioInfoShared,protMap,field,pl,new Location.Location2D(2400,0));
	      CreateNode(8,radioInfoShared,protMap,field,pl,new Location.Location2D(2800,0));

	      CreateNode(11,radioInfoShared,protMap,field,pl,new Location.Location2D(0,300));
	      CreateNode(12,radioInfoShared,protMap,field,pl,new Location.Location2D(400,300));
	      CreateNode(13,radioInfoShared,protMap,field,pl,new Location.Location2D(800,300));
	      CreateNode(14,radioInfoShared,protMap,field,pl,new Location.Location2D(1200,300));
	      CreateNode(15,radioInfoShared,protMap,field,pl,new Location.Location2D(1600,300));
 	      CreateNode(16,radioInfoShared,protMap,field,pl,new Location.Location2D(2000,300));
 	      CreateNode(17,radioInfoShared,protMap,field,pl,new Location.Location2D(2400,300));
	      CreateNode(18,radioInfoShared,protMap,field,pl,new Location.Location2D(2800,300));
	      
	      
         JistAPI.endAt(10*Constants.SECOND);
         
	      JistAPI.runAt(new Runnable()
	      {
	        public void run()
	        {    
	        	Iterator i =clusters.iterator();
	        	Cluster c;
	        	while(i.hasNext()){
	        		c=(Cluster)i.next();
	        		System.out.print(c);
	        	}
	        	
	        }
		}, JistAPI.END);          
	      
	    }
	    catch(Exception e) { e.printStackTrace(); }
	  }


	  public static void main(String args[])
	  {
	    TwoNodeTest();
	    //MultiNodeTest();
	  }
}
	
