package driver;

import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;

import jist.runtime.JistAPI;
import jist.swans.Constants;
import jist.swans.app.AppJava;
import jist.swans.bus.BusEthernetSwitch;
import jist.swans.field.Field;
import jist.swans.field.Gps;
import jist.swans.loc.LocationGod;
import jist.swans.loc.LocationServiceInterface;
import jist.swans.mac.Mac802_11;
import jist.swans.mac.MacAddress;
import jist.swans.mac.MacDumbBus;
import jist.swans.misc.Location;
import jist.swans.misc.Mapper;
import jist.swans.misc.Util;
import jist.swans.net.NetAddress;
import jist.swans.net.NetIp;
import jist.swans.net.NetMultiInterface;
import jist.swans.net.PacketLoss;
import jist.swans.radio.RadioInfo;
import jist.swans.radio.RadioNoise;
import jist.swans.radio.RadioNoiseIndep;
import jist.swans.route.RouteDhg;
import jist.swans.route.RouteDsr;
import jist.swans.trans.TransUdp;
import driver.mfrtest.Client;
import driver.mfrtest.Server;

public class dhgtest {
	  public static final byte[] SERVER_IP = {0, 0, 0, 2};
	  public static final int PORT = 3001;

	  public static class Server
	  {
	    public static void main(String args[])
	    {
	      try
	      {
	        System.out.println("server starting at t="+JistAPI.getTime());
	        DatagramSocket socket = new DatagramSocket(PORT);
	        while(true){
		        
		        byte buf[] = new byte[256];
		        DatagramPacket packet = new DatagramPacket(buf, buf.length);
		        socket.receive(packet);
		        
		        System.out.println("received at t="+JistAPI.getTime()+
		            " ("+packet.getLength()+" bytes) "
		            +(new String(packet.getData(), packet.getOffset(), packet.getLength())));
	        }
	        //socket.close();
	      }
	      catch(Exception e)
	      {
	        e.printStackTrace();
	      }
	    }
	  }

	  public static class Client
	  {
	    public static void main(String args[])
	    {
	      try
	      {
	    	  JistAPI.sleep(100*Constants.MILLI_SECOND);
	        System.out.println("client starting at t="+JistAPI.getTime());
	        
	        for(int i=0;i<50;i++){
	        	
		        DatagramSocket socket = new DatagramSocket();
		        byte[] buf = "hi".getBytes();
		        DatagramPacket packet = new DatagramPacket(
		          buf,
		          buf.length,
		          InetAddress.getByAddress(SERVER_IP),
		          PORT);
		
		        System.out.println("sent at t="+JistAPI.getTime());
		        System.out.flush();
		        socket.send(packet);
		        socket.close();
		        
		        JistAPI.sleep(100*Constants.MILLI_SECOND);
	        
	        }
	      }
	      catch(Exception e)
	      {
	        e.printStackTrace();
	      }
	    }
	  }
	  static Field field = new Field(new Location.Location2D(8000, 2000));
	  static jist.swans.route.RouteDhg.DsrStats stats=new jist.swans.route.RouteDhg.DsrStats();  
	  static RadioNoise radio3;
	  static RadioNoise radio4;
	 	  
	  
	  private static NetIp CreateWiredLayer(int i,BusEthernetSwitch etherSwitch,Mapper protMap,PacketLoss pl,RouteDhg mfr,NetAddress nextHop){

		  MacAddress macAddr=new MacAddress(i);
  
		  
		  MacDumbBus mac = new MacDumbBus(macAddr, (int)100e6);

		  
		  
	      NetIp net = new NetIp(new NetAddress(i+0xfe000000), protMap, pl, pl);

	      
	      byte intId = net.addInterface(mac.getProxy());	
	
	      etherSwitch.addMac(mac.getProxy(), macAddr);
	        

	      net.setProtocolHandler(Constants.NET_PROTOCOL_DSR, mfr.getProxy()); 

	      
	      net.setRouting(mfr.getProxy());


	      mac.setBusEntity(etherSwitch.getProxy());
	      
	      if(etherSwitch!=null)
	    	  mac.setBusEntity(etherSwitch.getProxy());	  	      

	      mac.setNetEntity(net.getProxy(), intId);	      
	      
	      
	      mfr.addWiredEntity(net.getProxy());     
	      
	      mfr.addRoutingEntry(nextHop, net);
	      
	      return net;
	  }
	  
	  

	  /**
	   * 
	   * Create a Acces Point with three interfaces : one wireless two wired (left and right)
	   * 
	   * 
	   * @param id adress of wireless interface
	   * @param radioInfoShared radio properties
	   * @param protMap Map
	   * @param field Field
	   * @param pl Packet lost model
	   * @param pos AP's position
	   * @param loc location service
	   * @param iwl id address of left wired interface
	   * @param iwr id address of right wired interface
	   * @param etherSwitchL switch that is connected to left wired interface
	   * @param etherSwitchR switch that is connected to right wired interface
	   * @param nextHopR next AP address to the right
	   * @param nextHopL next AP address to the left
	   * 
	   */
	  private static void CreateAP(int id,RadioInfo.RadioInfoShared radioInfoShared,Mapper protMap,Field field,PacketLoss pl,Location pos,LocationServiceInterface loc,int iwl,int iwr,BusEthernetSwitch etherSwitchL,BusEthernetSwitch etherSwitchR,NetAddress nextHopL,NetAddress nextHopR){

	      


	      // route
	      RouteDhg mfr = new RouteDhg(new NetAddress(iwl+0xfe000000),true);
	      //mfr.setBbProactif();
	      mfr.setStats(stats);
	      //mfr.setBbReactif();
	      mfr.setRegReactif();
	      mfr.setBbReactif();
	      //mfr.setRegProactif();
	      //mfr.setReactif();
	      
	      

	    /* Gps gps = new Gps(field,radio.getRadioInfo().getUnique().getID());
	      gps.start();
	      mfr.setGpsEntity(gps.getProxy());
	      loc.addNode(net.getAddress(), radio.getRadioInfo().getUnique().getID());
	      mfr.setLocService(loc);
*/

	      /*
	       * Create the wireless layers 
	       */
	      RadioNoise radio = new RadioNoiseIndep(id, radioInfoShared);
	      // mac
	      Mac802_11 mac = new Mac802_11(new MacAddress(id), radio.getRadioInfo());
	      // net
	      NetIp net = new NetIp(new NetAddress(id), protMap, pl, pl);	      
	      field.addRadio(radio.getRadioInfo(), radio.getProxy(), pos);
	      // radio hookup
	      radio.setFieldEntity(field.getProxy());
	      radio.setMacEntity(mac.getProxy());
	      // route hookup
	      mfr.addWirelessEntity(net.getProxy());
	      // net hookup
	      byte intId = net.addInterface(mac.getProxy());
	      net.setProtocolHandler(Constants.NET_PROTOCOL_DSR, mfr.getProxy());  
	      net.setRouting(mfr.getProxy());      
	      // mac hookup
	      mac.setRadioEntity(radio.getProxy());
	      mac.setNetEntity(net.getProxy(), intId);
      
	      if(iwr!=0 && etherSwitchR!=null)
	    	  CreateWiredLayer(iwr,etherSwitchR,protMap,pl,mfr,nextHopR);
	      
	      if(iwl!=0 & etherSwitchL!=null)
	    	  CreateWiredLayer(iwl,etherSwitchL,protMap,pl,mfr,nextHopL);	      

	  }	  
	  
	  private static NetIp CreateNode(int id,RadioInfo.RadioInfoShared radioInfoShared,Mapper protMap,Field field,PacketLoss pl,Location pos,LocationServiceInterface loc){
	      RadioNoise radio = new RadioNoiseIndep(id, radioInfoShared);

	      
	      // mac
	      Mac802_11 mac = new Mac802_11(new MacAddress(id), radio.getRadioInfo());
	      // net
	      NetIp net = new NetIp(new NetAddress(id), protMap, pl, pl);

	      
	    	

	      // route
	      RouteDhg mfr = new RouteDhg(net.getAddress());
	      mfr.setStats(stats);
	      mfr.setRegReactif();
	      mfr.setBbReactif();
	      //mfr.setRegProactif();
	      
	      //seule 1 communique
	      /*if(id==2)
	    	  mfr.setReactif();*/

	      
	    /* Gps gps = new Gps(field,radio.getRadioInfo().getUnique().getID());

	      
	      gps.start();

	      
	      mfr.setGpsEntity(gps.getProxy());

	      



	      loc.addNode(net.getAddress(), radio.getRadioInfo().getUnique().getID());
	      
	      
	      mfr.setLocService(loc);
	  
	      
	      
	      

*/

	      
	      field.addRadio(radio.getRadioInfo(), radio.getProxy(), pos);
	     
	      // radio hookup
	      radio.setFieldEntity(field.getProxy());
	  

	      radio.setMacEntity(mac.getProxy());
	      
	      // route hookup
	      mfr.setNetEntity(net.getProxy());

	      
	      // net hookup
	      byte intId = net.addInterface(mac.getProxy());

	      
	      net.setProtocolHandler(Constants.NET_PROTOCOL_DSR, mfr.getProxy());  
	      
	      net.setRouting(mfr.getProxy());

	      // mac hookup
	      mac.setRadioEntity(radio.getProxy());

	      
	      mac.setNetEntity(net.getProxy(), intId);

	      

		  return net;
	  }
	  
	  private static void MultiNodeTest()
	  {
	   try
	    {
	      // field
	      //Location bounds = new Location.Location2D(200, 2500);
	      
	 
	      
	      RadioInfo.RadioInfoShared radioInfoShared = RadioInfo.createShared(
	          Constants.FREQUENCY_DEFAULT, 
	          Constants.BANDWIDTH_DEFAULT,
	          Constants.TRANSMIT_DEFAULT, 
	          Constants.GAIN_DEFAULT,
	          Util.fromDB(Constants.SENSITIVITY_DEFAULT), 
	          Util.fromDB(Constants.THRESHOLD_DEFAULT),
	          Constants.TEMPERATURE_DEFAULT, 
	          Constants.TEMPERATURE_FACTOR_DEFAULT, 
	          Constants.AMBIENT_NOISE_DEFAULT);
	      
	      BusEthernetSwitch etherSwitch1 = new BusEthernetSwitch();
	      BusEthernetSwitch etherSwitch2 = new BusEthernetSwitch();	      
	      

	      // protocol mapper
	      Mapper protMap = new Mapper(Constants.NET_PROTOCOL_MAX);
	      protMap.mapToNext(Constants.NET_PROTOCOL_DSR);
	      protMap.mapToNext(Constants.NET_PROTOCOL_UDP);
	      // packet loss
	      PacketLoss pl = new PacketLoss.Zero();
	      // nodes
	      int i=1;
	      // radio
	      
	      //create the location service's
	      LocationGod loc = new LocationGod();
	      loc.setFieldEntity(field);
	      
	   /*   NetIp net1=CreateNode(1,radioInfoShared,protMap,field,pl,new Location.Location2D(0,0),loc.getProxy());
	      NetIp net2=CreateNode(2,radioInfoShared,protMap,field,pl,new Location.Location2D(500,0),loc.getProxy());
	      NetIp net3=CreateNode(3,radioInfoShared,protMap,field,pl,new Location.Location2D(500,100),loc.getProxy());
	      NetIp net4=CreateNode(4,radioInfoShared,protMap,field,pl,new Location.Location2D(1000,0),loc.getProxy());
	      NetIp net5=CreateNode(5,radioInfoShared,protMap,field,pl,new Location.Location2D(1500,0),loc.getProxy());
*/
	      
		  NetIp net1=CreateNode(1,radioInfoShared,protMap,field,pl,new Location.Location2D(0,1800),loc.getProxy());
	      NetIp net2=CreateNode(2,radioInfoShared,protMap,field,pl,new Location.Location2D(4000,1500),loc.getProxy());
	      CreateNode(3,radioInfoShared,protMap,field,pl,new Location.Location2D(4000,1750),loc.getProxy());
	      //CreateNode(4,radioInfoShared,protMap,field,pl,new Location.Location2D(4000,1000),loc.getProxy());
	      //CreateNode(5,radioInfoShared,protMap,field,pl,new Location.Location2D(4000,1500),loc.getProxy());
	      
		  CreateAP(6,radioInfoShared,protMap,field,pl,new Location.Location2D(0,2000),loc.getProxy(),10,0,etherSwitch1,null,new NetAddress(11+0xfe000000),new NetAddress(0));
		  CreateAP(7,radioInfoShared,protMap,field,pl,new Location.Location2D(2000,2000),loc.getProxy(),11,20,etherSwitch1,etherSwitch2,new NetAddress(10+0xfe000000),new NetAddress(12+0xfe000000));
		  CreateAP(8,radioInfoShared,protMap,field,pl,new Location.Location2D(4000,2000),loc.getProxy(),12,0,etherSwitch2,null,new NetAddress(11+0xfe000000),new NetAddress(0));
	     
	      
	      // trans
	      TransUdp udp1 = new TransUdp();
	      TransUdp udp2 = new TransUdp();
	     /* TransUdp udp3 = new TransUdp();
	      TransUdp udp5 = new TransUdp();*/
	      
	      // trans hookup
	      udp1.setNetEntity(net1.getProxy());
 
	      udp2.setNetEntity(net2.getProxy());

	      
	      
	      
	      net1.setProtocolHandler(Constants.NET_PROTOCOL_UDP, udp1.getProxy());
	      net2.setProtocolHandler(Constants.NET_PROTOCOL_UDP, udp2.getProxy());
      
	      MyCBR.Client client = new MyCBR.Client(udp1.getProxy(),1000,20,3,new NetAddress(1),new NetAddress(2));
	      MyCBR.Server server = new MyCBR.Server(udp2.getProxy(),new NetAddress(1));	      
	      
	      // applications
	/*      AppJava server = new AppJava(Server.class);
	      server.setUdpEntity(udp2.getProxy());

	      AppJava client3 = new AppJava(Client.class);
	      client3.setUdpEntity(udp1.getProxy());	  

	      // run apps
	      
*/	     
	      server.getProxy().run(); 
	      JistAPI.sleep(1);
	      client.getProxy().run();

	      
	      JistAPI.endAt((3)*Constants.SECOND);
	      
	      
	      
	  //    JistAPI.sleep(Constants.SECOND * 5 );
	
	      
	      

	      
	      
	      
	      JistAPI.runAt(new Runnable()
	      {
	        public void run()
	        {        	  
	            field.getProxy().moveRadioOff(new Integer(2), new Location.Location2D(0,-200) );
	            //field.getProxy().moveRadioOff(radio4.getRadioInfo().getUnique().getID(), new Location.Location2D(0,100) );
	        }
		}, (int)((double)Constants.SECOND * .6));
	      
	      JistAPI.runAt(new Runnable()
	      {
	        public void run()
	        {
	          System.out.println(stats);
	        }
	      }, JistAPI.END);   	      
	       
	      
	    }
	    catch(Exception e) { e.printStackTrace(); }
	  }


	  public static void main(String args[])
	  {
	    MultiNodeTest();
	  }

}


// jist jist.swans.Main driver.hybridrunway_dhg -v  -T 1 -l 8000 -i 8 -a 8 -A 1000  -b 1 -r 800000 -k 512 -p MFR   -R 11:24.5:1.559e-8:3.652e-7 > out_ttl.mfr