package driver;

import jist.runtime.JistAPI;
import jist.swans.Constants;
import jist.swans.bus.BusEthernetSwitch;
import jist.swans.field.Fading;
import jist.swans.field.Mobility;
import jist.swans.field.PathLoss;
import jist.swans.field.Placement;
import jist.swans.field.Spatial;
import jist.swans.loc.LocationServiceInterface;
import jist.swans.mac.Mac802_11;
import jist.swans.mac.MacAddress;
import jist.swans.mac.MacDumbBus;
import jist.swans.misc.Location;
import jist.swans.misc.Mapper;
import jist.swans.misc.Util;
import jist.swans.net.NetAddress;
import jist.swans.net.NetIp;
import jist.swans.net.NetMultiInterface;
import jist.swans.net.PacketLoss;
import jist.swans.field.Field;
import jist.swans.radio.RadioInfo;
import jist.swans.radio.RadioNoise;
import jist.swans.radio.RadioNoiseIndep;
import jist.swans.route.RouteDhg;
import jist.swans.route.RouteDsr;
import jist.swans.route.RouteInterface;
import jist.swans.route.RouteMFR;
import jist.swans.route.RouteDhg.DsrStats;
import jist.swans.runway.RunWay;
import jist.swans.runway.RunWayCar;
import jist.swans.runway.RunWayCar.RunWayCarStats;
import jist.swans.runway.NewCarEventInterface;
import jist.swans.runway.JRunWayWindow;
import jist.swans.trans.CircularBuffer;
import jist.swans.trans.TransUdp;
import jist.runtime.JistAPI;
import jist.swans.app.AppJava;
import jargs.gnu.CmdLineParser;

import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.util.Hashtable;
import java.util.Random;
import java.util.ArrayList;
import java.util.Iterator;



import jist.swans.field.Field.RadioData;

public class hybridrunway_dhg implements NewCarEventInterface{
	
	
	  private static class TraficSource
	  {
		  static int next_id=0;
		  int idSocket;
		  int idClient;
		  int idServer;
		  MyCBR.Client client;
		  MyCBR.Server server;
		  
		  
		  public TraficSource(){
			  idSocket=++next_id;
		  }
	  }
	  
	  private static class OptionsRadio
	  {

		    /**
		     * Bandwidth (units: bits/second).
		     */
		    protected int bandwidth;

		    /**
		     * Transmission power (units: dBm).
		     */
		    protected double transmit;

		    /**
		     * Reception sensitivity (units: mW).
		     */
		    protected double sensitivity_mW;

		    /**
		     * Reception threshold (units: mW).
		     */
		    protected double threshold_mW;
  
		    public String toString(){
		    	String s="";
		    	
		    	s+="Bande passante : "+bandwidth+" bits/s ";
		    	s+="Puissance : "+transmit+" dBm ";
		    	s+="Sensibilité : " + sensitivity_mW+" mW ";
		    	s+="Seuil : " + threshold_mW+" mW";		    	
		    	
		    	return s;
		    }
	  }
	  
	  private static class CommandLineOptions
	  {
		  boolean help;
		  int nbrLane;
		  float sizeLan;
		  float sizeRunway;
		  float speedTarget;
		  float intensity;
		  float precision;
		  boolean doubleMind;
		  boolean trafficstatic;
		  boolean circulaire;
		  int nbrAP;
		  int advInter;
		  int diameter;
		  int ttlRReq;
		  int helloInter;
		  int protocol;
		  String filePosRw;
		  boolean verbose;
		  boolean politique;
		  int nbSource;
		  float bitrate;
		  int sizePacket;
		  int timeSim;
		  boolean gui;
		  String name; //nom de la simulation
		  OptionsRadio optRadio;
		  //ajouté temps de simu
		  
		  public String toString(){
			  String s=name+"\n";
			  
		
			  s+="Nombre de voie :"+nbrLane+"\n";
			  s+="Taille d'une voie : "+sizeLan+"\n";
			  s+="Longueur de l'autoroute : "+sizeRunway+"\n";
			  s+="Vitesse cible moyenne : "+speedTarget+"\n";
			  s+="Intensité : "+intensity+"\n";
			  s+="Precision : "+precision+"\n";
			  s+="Double sens : "+doubleMind+"\n";
			  s+="Traffic statique : "+trafficstatic+"\n";			  
			  s+="Nombre de point d'accès : "+nbrAP+"\n";
			  s+="Interval d'avertissement : "+advInter+"\n";	
			  s+="TTL APAdv" + " : "+diameter+"\n";	
			  s+="TTL RReq" + " : " + ttlRReq + "\n" ;
			  s+="Inter Hello" + " : "+helloInter+"\n";					  
			  s+="Protocole : "+protocol+"\n";
			  s+="Politique : "+(politique ? "Reactif" : "Proactif") +"\n";			  
			  s+="Débit : "+bitrate+"\n";	
			  s+="Taille d'un paquet : "+sizePacket+"\n";
			  s+="Radio : "+optRadio+"\n";
			  s+="Temps du simulation : "+timeSim+"\n";
			  
			  return s;
		  }
	  }
	  
	  /** Prints a usage statement. */
	  private static void showUsage() 
	  {
	    System.out.println("Usage: jist jist.swans.Main  driver.hybridrunway [options]");
	    System.out.println();
	    System.out.println("  -h, --help           affiche ce message");
	    System.out.println("  -n, --name           nom de la simulation");
	    System.out.println("  -N, --nbrlane        nombre de voie");	    
	    System.out.println("  -T, --timesim        temps de la simulation");	    
	    System.out.println("  -s, --sizelane       taill d'une voie (en m)");
	    System.out.println("  -l, --sizerunway     longueur de l'autoroute (en m)");
	    System.out.println("  -t, --speedtarget    vitesse cible moyenne (en m/s)");
	    System.out.println("  -i, --intensity      intensité (en nombre de véhicule par kilomettre)");
	    System.out.println("  -d, --precision      precision (en seconde). Temps d'attende entre chaque étape");
	    System.out.println("  -m, --doublemind     double sens");
	    System.out.println("  -S, --static     	   les véhicules ne bouge pas");
	    System.out.println("  -c, --circulaire     autoroute circulaire (rond point géant)");	    
	    System.out.println("  -a, --nopmbreap      nombre de point d'accéss");
	    System.out.println("  -A, --advinter       temps entre deux AP advertissement");	
	    System.out.println("  -D, --diameter       TTL d'un AP advertissement");
	    System.out.println("  -Q, --ttlrreq        TTL d'un RREQ");	    
	    System.out.println("  -H, --hello          temp entre deux DHG hello");		    
	    System.out.println("  -p, --protocole      protocole (DSR,MFR)");
	    System.out.println("  -P, --politique      politique (reactif,proactif)");	    
	    System.out.println("  -b, --nbsource       nombre de source");	 
	    System.out.println("  -B, --choixsource    politique des choix des sources");	 	    
	    System.out.println("  -r, --bitrate        Débit (en bits/s");
	    System.out.println("  -k, --sizepacket     Taille d'un paquet (en octet");
	    System.out.println("  -R, --radioinfo      Proprièté de la transmission radio (bande passante:puissance:sensibilite:seuil)");	 
	    System.out.println("  -f  --file           Lit les position des vehicule à partir d'un fichier");
	    System.out.println("  -v, --verbose        Affiche toutes les statistiques");	    
	    System.out.println("  -g, --gui            Affiche une GUI");	    

	    System.out.println();
	    System.out.println("Sortie par défaut : delai moyen,delai max,PDR,Overhead,longeure de chemin moyen");	    
	    System.out.println();
	    System.out.println("e.g.");
	    System.out.println("  jist jist.swans.Main ");
	    System.out.println();
	  }
  
	  
	  private static CommandLineOptions parseCommandLineOptions(String[] args)
	    throws CmdLineParser.OptionException
	  {

	    CmdLineParser parser = new CmdLineParser();
	    CmdLineParser.Option opt_help = parser.addBooleanOption('h', "help");
	    CmdLineParser.Option opt_nbrLane = parser.addIntegerOption('N', "nbrlane");
	    CmdLineParser.Option opt_timesimu = parser.addIntegerOption('T', "timesimu");	    
	    CmdLineParser.Option opt_sizelane = parser.addDoubleOption('s', "sizelane");
	    CmdLineParser.Option opt_sizerunway = parser.addDoubleOption('l', "sizerunway");
	    CmdLineParser.Option opt_speedtarget = parser.addDoubleOption('t', "speedtarget");
	    CmdLineParser.Option opt_intensity = parser.addDoubleOption('i', "intensity");
	    CmdLineParser.Option opt_presicion = parser.addDoubleOption('d', "precision");
	    CmdLineParser.Option opt_doublemind = parser.addBooleanOption('m', "doublemind");
	    CmdLineParser.Option opt_static = parser.addBooleanOption('S', "static");
	    CmdLineParser.Option opt_circ = parser.addBooleanOption('c', "circulaire");	    
	    CmdLineParser.Option opt_nombreap = parser.addIntegerOption('a', "nombreap");
	    CmdLineParser.Option opt_advinter = parser.addIntegerOption('A', "advinter");	
	    CmdLineParser.Option opt_diameter = parser.addIntegerOption('D', "diameter");
	    CmdLineParser.Option opt_ttlrreq = parser.addIntegerOption('Q', "ttlrreq");
	    CmdLineParser.Option opt_hello = parser.addIntegerOption('H', "hello");
	    CmdLineParser.Option opt_protocol = parser.addStringOption('p', "protocol");
	    CmdLineParser.Option opt_politique = parser.addStringOption('P', "politique");
	    CmdLineParser.Option opt_verbose = parser.addBooleanOption('v', "verbose");
	    CmdLineParser.Option opt_bitrate = parser.addDoubleOption('r', "bitrate");
	    CmdLineParser.Option opt_nbsource = parser.addIntegerOption('b', "nbsource");	
	    CmdLineParser.Option opt_radioinfo = parser.addStringOption('R', "radioinfo");		    
	    CmdLineParser.Option opt_sizepacket = parser.addIntegerOption('k', "sizepacket");
	    CmdLineParser.Option opt_file = parser.addStringOption('f', "file");
	    CmdLineParser.Option opt_name = parser.addStringOption('n', "name");
	    
	    CmdLineParser.Option opt_gui = parser.addBooleanOption('g', "gui");
	    
	    parser.parse(args);
	    
		  
		    CommandLineOptions cmdOpts = new CommandLineOptions();
		    cmdOpts.optRadio=new OptionsRadio();
		    // help
		    if(parser.getOptionValue(opt_help) != null)
		    {
		      cmdOpts.help = true;
		    }
		    
		    if(parser.getOptionValue(opt_doublemind) != null)
		    {
		      cmdOpts.doubleMind = true;
		    }
		    	
		    
		    if(parser.getOptionValue(opt_static) != null)
		    {
		      cmdOpts.trafficstatic = true;
		    }		
		    
		    if(parser.getOptionValue(opt_circ) != null)
		    {
		      cmdOpts.circulaire = true;
		    }				    
		    
		    if(parser.getOptionValue(opt_verbose) != null)
		    {
		      cmdOpts.verbose = true;
		    }	
		    
		    if(parser.getOptionValue(opt_gui) != null)
		    {
		      cmdOpts.gui = true;
		    }	
		    
		    if(parser.getOptionValue(opt_timesimu) != null)
		    {
		    	cmdOpts.timeSim= ((Integer)parser.getOptionValue(opt_timesimu)).intValue();
		    }else
		    	cmdOpts.timeSim=15;
		    
		    if(parser.getOptionValue(opt_nbrLane) != null)
		    {
		    	cmdOpts.nbrLane= ((Integer)parser.getOptionValue(opt_nbrLane)).intValue();
		    }else
		    	cmdOpts.nbrLane=3;
		    
		    if(parser.getOptionValue(opt_nombreap) != null)
		    {
		    	cmdOpts.nbrAP= ((Integer)parser.getOptionValue(opt_nombreap)).intValue();
		    	cmdOpts.nbrAP=Math.min(cmdOpts.nbrAP,30);
		    }else
		    	cmdOpts.nbrAP = 0;
		    
		    if(parser.getOptionValue(opt_advinter) != null)
		    {
		    	cmdOpts.advInter= ((Integer)parser.getOptionValue(opt_advinter)).intValue();
		    }else
		    	cmdOpts.advInter = 1000;		    
		    
		    if(parser.getOptionValue(opt_diameter) != null)
		    {
		    	cmdOpts.diameter= ((Integer)parser.getOptionValue(opt_diameter)).intValue();
		    }else
		    	cmdOpts.diameter = 8;	

		    if(parser.getOptionValue(opt_ttlrreq) != null)
		    {
		    	cmdOpts.ttlRReq= ((Integer)parser.getOptionValue(opt_ttlrreq)).intValue();
		    }else
		    	cmdOpts.ttlRReq = 6;			    
		    
		    
		    if(parser.getOptionValue(opt_hello) != null)
		    {
		    	cmdOpts.helloInter= ((Integer)parser.getOptionValue(opt_hello)).intValue();
		    }else
		    	cmdOpts.helloInter = 100;				    
	
		    if(parser.getOptionValue(opt_sizepacket) != null)
		    {
		    	cmdOpts.sizePacket= ((Integer)parser.getOptionValue(opt_sizepacket)).intValue();
		    }else
		    	cmdOpts.sizePacket = 128;	
		    
		    if(parser.getOptionValue(opt_nbsource) != null)
		    {
		    	cmdOpts.nbSource= ((Integer)parser.getOptionValue(opt_nbsource)).intValue();
		    }else
		    	cmdOpts.nbSource = 1;			    
	
		    if(parser.getOptionValue(opt_file) != null)
		    {
		    	cmdOpts.filePosRw = (String)parser.getOptionValue(opt_file);
		    }else	
		    	cmdOpts.filePosRw=null;

		    if(parser.getOptionValue(opt_name) != null)
		    {
		    	cmdOpts.name = (String)parser.getOptionValue(opt_name);
		    }else	
		    	cmdOpts.name="Simulation";
		    		    
		    
		    if(parser.getOptionValue(opt_protocol) != null)
		    {
		    	String protString = (String)parser.getOptionValue(opt_protocol);
		    	
		    	if(protString.equalsIgnoreCase("DSR"))
		    		cmdOpts.protocol=Constants.NET_PROTOCOL_DSR;
		    	else if(protString.equalsIgnoreCase("AODV"))
		    		cmdOpts.protocol=Constants.NET_PROTOCOL_AODV;
		    	else if(protString.equalsIgnoreCase("ZRP"))
		    		cmdOpts.protocol=Constants.NET_PROTOCOL_ZRP;
		    	else if(protString.equalsIgnoreCase("MFR"))
		    		cmdOpts.protocol=Constants.NET_PROTOCOL_MFR;
		    }else	
		    	cmdOpts.protocol=Constants.NET_PROTOCOL_DSR;
		    

		    if(parser.getOptionValue(opt_politique) != null)
		    {
		    	String protString = (String)parser.getOptionValue(opt_politique);
		    	
		    	if(protString.equalsIgnoreCase("Reactif"))
		    		cmdOpts.politique=true;
		    	else if(protString.equalsIgnoreCase("Proactif"))
		    		cmdOpts.politique=false;
		    	else cmdOpts.politique=false;
		    		

		    }else	
		    	cmdOpts.politique=false;
		    		    
		    
		    if(parser.getOptionValue(opt_sizerunway) != null)
		    {
		    	cmdOpts.sizeRunway= ((Double)parser.getOptionValue(opt_sizerunway)).floatValue();
		    }else
		    	cmdOpts.sizeRunway=5000f;
		    
		    if(parser.getOptionValue(opt_speedtarget) != null)
		    {
		    	cmdOpts.speedTarget= ((Double)parser.getOptionValue(opt_speedtarget)).floatValue();
		    }else
		    	cmdOpts.speedTarget=33.34f;
		    
		    if(parser.getOptionValue(opt_bitrate) != null)
		    {
		    	cmdOpts.bitrate= ((Double)parser.getOptionValue(opt_bitrate)).floatValue();
		    }else
		    	cmdOpts.bitrate=10240;		    
		    
		    if(parser.getOptionValue(opt_intensity) != null)
		    {
		    	cmdOpts.intensity= ((Double)parser.getOptionValue(opt_intensity)).floatValue();
		    }else
		    	cmdOpts.intensity=5;
		    
		    if(parser.getOptionValue(opt_sizelane) != null)
		    {
		    	cmdOpts.sizeLan= ((Double)parser.getOptionValue(opt_sizelane)).floatValue();
		    }else
		    	cmdOpts.sizeLan=3;		    	
		    
		    if(parser.getOptionValue(opt_presicion) != null)
		    {
		    	cmdOpts.precision= ((Double)parser.getOptionValue(opt_presicion)).floatValue();
		    }else
		    	cmdOpts.precision=0.05f;
		    
		    
		    if(parser.getOptionValue(opt_radioinfo) != null)
		    {
		    	String opt[] =  ((String)parser.getOptionValue(opt_radioinfo)).split(":") ;
		    	
		    	
		    	
		    	cmdOpts.optRadio.bandwidth= Integer.parseInt(opt[0])*((int)1e6);
		    	cmdOpts.optRadio.transmit=Double.parseDouble(opt[1]);
		    	cmdOpts.optRadio.sensitivity_mW=Double.parseDouble(opt[2]);
		    	cmdOpts.optRadio.threshold_mW=Double.parseDouble(opt[3]);
		    	
		    }else{
		    	cmdOpts.optRadio.bandwidth=(int)2e6;
		    	cmdOpts.optRadio.sensitivity_mW=1.559e-8;
		    	cmdOpts.optRadio.threshold_mW=3.652e-7;
		    	cmdOpts.optRadio.transmit=24.5;
		    	
		    }
		    		    
		    
		    return cmdOpts;
	  }
	  
		public  DsrStats statsDsr=new DsrStats();		
		public  RunWayCarStats statsRw=new RunWayCarStats() ;
		protected NewCarEventInterface self;
		public  RunWay[] rw;
		public  Location bounds;
		public  Field field;
		public  RadioInfo.RadioInfoShared radioInfoShared;
		public  Mapper protMap;
		public  PacketLoss pl;
		public jist.swans.runway.PlacementInterface[] place;
		public int nextIdNode=1;
		public int protocole=0;
		public CommandLineOptions options;
		public ArrayList traficSources;
		long timeStarted;
	
		
		
		private void CreateApplicationLayer(int id,NetIp net,RouteDhg mfr,Location pos){
			  for( Iterator it=traficSources.iterator() ; it.hasNext() ; ){
				  TraficSource t=(TraficSource)it.next();
				  
			      if(mfr!=null && (t.idServer==id || t.idClient==id))
			    	  mfr.setIdle(false);
				  
				  if(t.idServer==id){
					  TransUdp udp = new TransUdp();
					    udp.setNetEntity(net.getProxy());
					    net.setProtocolHandler(Constants.NET_PROTOCOL_UDP, udp.getProxy());
					  t.server = new MyCBR.Server(udp.getProxy(),new NetAddress(id),t.idSocket);
					  t.server.getProxy().run();
					  if(options.verbose)
						  System.out.println(JistAPI.getTime()+" ajout_du_serveur "+t.idSocket+" "+new NetAddress(id)+ " "+pos.getX()+ " "+pos.getY());

				  }
			
				  if(t.idClient==id){
					  TransUdp udp = new TransUdp();
					    udp.setNetEntity(net.getProxy());
					    net.setProtocolHandler(Constants.NET_PROTOCOL_UDP, udp.getProxy());

					  t.client = new MyCBR.Client(udp.getProxy(),options.bitrate,options.sizePacket,options.timeSim,new NetAddress(id),new NetAddress(t.idServer),t.idSocket);
					  t.client.getProxy().run();
					  if(options.verbose)
						  System.out.println(JistAPI.getTime()+" ajout_client_cbr " + t.idSocket+" " +new NetAddress(id)+  " "+pos.getX()+ " "+pos.getY());

				  }
				  
			  }	   		      
			
		}
		
		
		  private  NetIp CreateWiredLayer(int i,BusEthernetSwitch etherSwitch,RouteInterface dsr){

			  MacAddress macAddr=new MacAddress(i);
	  
			  
			  MacDumbBus mac = new MacDumbBus(macAddr, (int)100e6);

			  
			  
		      NetIp net = new NetIp(new NetAddress(i+0xfe000000), protMap, pl, pl);

		      
		      byte intId = net.addInterface(mac.getProxy());	
		
		      etherSwitch.addMac(mac.getProxy(), macAddr);
		        

		      net.setProtocolHandler(Constants.NET_PROTOCOL_DSR, dsr); 

		      
		      net.setRouting(dsr);


		      mac.setBusEntity(etherSwitch.getProxy());
		      
		      if(etherSwitch!=null)
		    	  mac.setBusEntity(etherSwitch.getProxy());	  	      

		      mac.setNetEntity(net.getProxy(), intId);	      
		      
		      
		      return net;
		  }
		
		
		


		  
		  

		  /**
		   * 
		   * Create a Acces Point with three interfaces : one wireless two wired (left and right)
		   * 
		   * 
		   * @param id adress of wireless interface
		   * @param radioInfoShared radio properties
		   * @param protMap Map
		   * @param field Field
		   * @param pl Packet lost model
		   * @param pos AP's position
		   * @param loc location service
		   * @param iwl id address of left wired interface
		   * @param iwr id address of right wired interface
		   * @param etherSwitchL switch that is connected to left wired interface
		   * @param etherSwitchR switch that is connected to right wired interface
		   * @param nextHopR next AP address to the right
		   * @param nextHopL next AP address to the left
		   * 
		   */
		  private void CreateAP(int id,Location pos,int iwl,int iwr,BusEthernetSwitch etherSwitchL,BusEthernetSwitch etherSwitchR,int nextHopL,int nextHopR){

			  if(options.verbose)
				  System.out.println(JistAPI.getTime()+" Create_AP "+id + " " + new NetAddress(iwl+0xfe000000) + " " + pos.getX()+ " "+pos.getY());	
		      
		      // radio hookup
		      RadioNoise radio = new RadioNoiseIndep(id, radioInfoShared);
		      field.addRadio(radio.getRadioInfo(), radio.getProxy(), pos);
		      radio.setFieldEntity(field.getProxy());	      
		      
		      // mac hookup
		      Mac802_11 mac = new Mac802_11(new MacAddress(id), radio.getRadioInfo());
		      radio.setMacEntity(mac.getProxy());
		      mac.setRadioEntity(radio.getProxy());			      
		      	      
		      // net
		      NetIp net = new NetIp(new NetAddress(id), protMap, pl, pl);	      
		      byte intId = net.addInterface(mac.getProxy());		      
		      mac.setNetEntity(net.getProxy(), intId);		      
		      
		      
		      switch(options.protocol){
		      
		      case Constants.NET_PROTOCOL_DSR:
		    	  
			      // route
			      RouteDsr dsr = new RouteDsr(new NetAddress(iwl+0xfe000000));
			      dsr.setStats(statsDsr);
			      dsr.setTtlRReq((byte)options.ttlRReq);

		
			      NetMultiInterface  netMI = new NetMultiInterface();
			      netMI.addNetIp(net);
			      net.setProtocolHandler(Constants.NET_PROTOCOL_DSR, dsr.getProxy());  
			      net.setRouting(dsr.getProxy());  
			      dsr.setNetEntity(netMI.getProxy());
			      
			      
			      
			      if(iwr!=0 && etherSwitchR!=null){
			    	  NetIp netw=CreateWiredLayer(iwr,etherSwitchR,dsr.getProxy());
			    	  netMI.addNetIp(netw);
			      }
			      
			      if(iwl!=0 & etherSwitchL!=null){
			    	  NetIp netw=CreateWiredLayer(iwl,etherSwitchL,dsr.getProxy());
			    	  netMI.addNetIp(netw);
			      }
			      
			      break;		      
		      
		      case Constants.NET_PROTOCOL_MFR:
		    	  
			      // route
			      RouteDhg mfr = new RouteDhg(new NetAddress(iwl+0xfe000000),true);
			      if (options.politique){
			    	  //mfr.setBbReactif();
				      mfr.setRegReactif();
			      }
			      else{
				      mfr.setRegProactif();
				      //mfr.setBbProactif();
			      }
			      mfr.setBbProactif();	      
			      
			      

			      mfr.setStats(statsDsr);
			      mfr.setTtlRReq((byte)options.ttlRReq);
			      mfr.setAdvertissementInter(options.advInter*Constants.MILLI_SECOND);
			      mfr.setHelloInter(options.helloInter*Constants.MILLI_SECOND);
			      mfr.setDiameter((byte)options.diameter);
			      //mfr.setBbReactif();
			      //mfr.setReactif(); 
			      mfr.addWirelessEntity(net.getProxy());
			      
			      // net hookup
			      net.setProtocolHandler(Constants.NET_PROTOCOL_DSR, mfr.getProxy());  
			      net.setRouting(mfr.getProxy());      
			      

			      if(iwr!=0 && etherSwitchR!=null){
			    	  NetIp netw=CreateWiredLayer(iwr,etherSwitchR,mfr.getProxy());
				      mfr.addWiredEntity(netw.getProxy());     
				      mfr.addRoutingEntry(new NetAddress(nextHopR+0xfe000000), netw);				     
			      }
			      
			      if(iwl!=0 & etherSwitchL!=null){
			    	  NetIp netw=CreateWiredLayer(iwl,etherSwitchL,mfr.getProxy());	      
				      mfr.addWiredEntity(netw.getProxy());     
				      mfr.addRoutingEntry(new NetAddress(nextHopL+0xfe000000), netw);	
			      }
			      
			      CreateApplicationLayer(id,net,mfr,pos);
			      
			      break;
			      
		      }
	      

		  }	  
		  
		  private NetIp CreateNode(int id,Location pos){
			  
//			 radio hookup
		      RadioNoise radio = new RadioNoiseIndep(id, radioInfoShared);
		      field.addRadio(radio.getRadioInfo(), radio.getProxy(), pos);
		      radio.setFieldEntity(field.getProxy());

		      // mac hookup
		      Mac802_11 mac = new Mac802_11(new MacAddress(id), radio.getRadioInfo());	
		      radio.setMacEntity(mac.getProxy());
		      mac.setRadioEntity(radio.getProxy());
	      
		      
		      // net hookup
		      NetIp net = new NetIp(new NetAddress(id), protMap, pl, pl);		      
		      byte intId = net.addInterface(mac.getProxy());
		      mac.setNetEntity(net.getProxy(), intId);	

		      RouteDhg mfr=null;
		      switch(options.protocol){
		      case Constants.NET_PROTOCOL_MFR:
			      // route
		    	  mfr = new RouteDhg(net.getAddress());
			      mfr.setStats(statsDsr);
			      mfr.setTtlRReq((byte)options.ttlRReq);
			      if (options.politique){
			    	  //mfr.setBbReactif();
				      mfr.setRegReactif();
			      }
			      else{
				      mfr.setRegProactif();
				      //mfr.setBbProactif();
			      }
			      mfr.setBbProactif();	      
			      
			      mfr.setBbReactif();
			      mfr.setAdvertissementInter(options.advInter*Constants.MILLI_SECOND);
			      mfr.setHelloInter(options.helloInter*Constants.MILLI_SECOND);
			      mfr.setIdle(true);
			      mfr.setDiameter((byte)options.diameter);
			      // route hookup
			      mfr.setNetEntity(net.getProxy());
			      
			      net.setProtocolHandler(Constants.NET_PROTOCOL_DSR, mfr.getProxy());  
			      net.setRouting(mfr.getProxy());
			      

		    	  break;
		      case Constants.NET_PROTOCOL_DSR:
		          RouteDsr dsr = new RouteDsr(net.getAddress());	          
		          dsr.setNetEntity(net.getProxy());
		          dsr.setStats(statsDsr);
			      dsr.setTtlRReq((byte)options.ttlRReq);
				  net.setProtocolHandler(Constants.NET_PROTOCOL_DSR, dsr.getProxy());
				  net.setRouting(dsr.getProxy());
		    	  break;		    	  
		      }
		    	  
		    	  

		      CreateApplicationLayer(id,net,mfr,pos);
		      
		      

			  return net;
		  }		
		
		

		  void CreateBackBone(){
			  
			float sizeRw=options.sizeRunway;
		    float ray=(sizeRw/(float)(2.0*Math.PI));			  
			  
		      BusEthernetSwitch etherSwitch_boucle = new BusEthernetSwitch(); 
		      BusEthernetSwitch etherSwitch_prev =etherSwitch_boucle,etherSwitch_next = null;

		      
		      
		      float inter=sizeRw/(options.nbrAP+1);
		      
		      

		      
		      for(int i=1;i<=options.nbrAP;i++){
		    	  float x,y;
		    	  if(options.circulaire){
		    		  float rad=((float)i/(float)(options.nbrAP))*2.0f*(float)Math.PI;
			  		  x = (ray-1.0f)*(float)Math.cos(rad) +ray ;
					  y = (ray-1.0f)*(float)Math.sin(rad) +ray ;
		    	  }else{
		    		  x=inter*i;
		    		  y=1;
		    	  }
		    	  
		    	  //si c'est le derniere AP, on utilise le switch previous du premier AP
		    	  /*if(i==(options.nbrAP-1))
		    		  etherSwitch_next = etherSwitch_boucle;
		    	  else*/
		    		  etherSwitch_next = new BusEthernetSwitch();
		    	  
			      //addGatewayNode(nextIdNode++,nextIdNode++,);
			      
			      CreateAP(nextIdNode, new Location.Location2D(x,y), nextIdNode+1, nextIdNode+2, etherSwitch_prev, etherSwitch_next, nextIdNode<1? 0:nextIdNode-2, nextIdNode+4);
			      
			      nextIdNode+=3;
			      
			      etherSwitch_prev=etherSwitch_next;
		      }
			  
			  
		  }
		
		
		
		
	public void newCarEvent(int id,Location loc){
	//System.out.println("new car !! " +nextIdNode + " "+ loc + JistAPI.getTime());
		/*if(options.verbose)
			System.out.println(JistAPI.getTime()+" Nouvelle_voiture : "+ id + " " + new NetAddress(id) + loc);
		*/
		CreateNode( id,loc);

		
	}
	
	/**
	 * Call when a car is deleted
	 * @param id node id
	 */
	public void deleteCarEvent(int id){
		for( Iterator it=traficSources.iterator() ; it.hasNext() ; ){
			  TraficSource t=(TraficSource)it.next();
			  System.out.println("\nDelete the idle node "+id);
			  if(t.idClient==id){
				  t.client.stop();
				  System.out.println("Delete the no idle node "+id);
			  }
		}
	}
	
	public hybridrunway_dhg() {
		
		this.self = (NewCarEventInterface)JistAPI.proxy(this, NewCarEventInterface.class);
	}	
	



	private double getStatDelayAvg(){
		double val=0.0;
		int nbVal=0;
	    
		for( Iterator it=traficSources.iterator() ; it.hasNext() ; ){
			TraficSource t=(TraficSource)it.next();
			
			if(t.server.getDelayAvg()!=0){
				val+=t.server.getDelayAvg();
				nbVal++;
			}
		}
		
		return val/nbVal;
	}
	
	private double getStatDelayMax(){
		double val=0.0;
	    
		for( Iterator it=traficSources.iterator() ; it.hasNext() ; ){
			TraficSource t=(TraficSource)it.next();
			if(val<t.server.getDelayMax())
				val=t.server.getDelayMax();
		}
		
		return val;		
	}	

	private double getStatThroughput(){
		double val=0.0;
	    
		for( Iterator it=traficSources.iterator() ; it.hasNext() ; ){
			TraficSource t=(TraficSource)it.next();
			
			val+= ((double)(t.server.getPacketsSizeReceived()*8))  /  (double)(options.timeSim)  ;

		}
		
		return val/(double)traficSources.size();		
	}
	
	private double getStatPDR(){
		double val=0.0;
	    
		for( Iterator it=traficSources.iterator() ; it.hasNext() ; ){
			TraficSource t=(TraficSource)it.next();
			val+=((double)t.server.getPacketsReceived()/(double)t.client.getPacketsSended());
		}
		
		return val/(double)traficSources.size();			
	}
	
	private double getNbPacketSend(){
		int val=0;
	    
		for( Iterator it=traficSources.iterator() ; it.hasNext() ; ){
			TraficSource t=(TraficSource)it.next();
			val+=t.client.getPacketsSended();
		}
		
		return val;			
	}	
	
	private double getNbPacketReceived(){
		int val=0;
	    
		for( Iterator it=traficSources.iterator() ; it.hasNext() ; ){
			TraficSource t=(TraficSource)it.next();
			val+=t.server.getPacketsReceived();
		}
		
		return val;			
	}		

	public void  buildFieldRunway(){

		timeStarted = System.currentTimeMillis();

	    if(options.doubleMind)
	    	rw= new RunWay[2];
	    else
	    	rw= new RunWay[1];	    	

		float sizeRw=options.sizeRunway;
	    float ray=(sizeRw/(float)(2.0*Math.PI));
		
		rw[0]=new RunWay(options.nbrLane,options.sizeLan,sizeRw,options.speedTarget,options.intensity,options.precision,options.doubleMind,new Location.Location2D(1,4));
		
		if(options.doubleMind)
			rw[1]=new RunWay(options.nbrLane,options.sizeLan,sizeRw,options.speedTarget,options.intensity,options.precision,!options.doubleMind,new Location.Location2D(1,14));
		
		
		//rw[2]=new RunWay(2,3,5000,33.34f,10,0.050f,true,new Location.Location2D(1,30));
		//rw[3]=new RunWay(2,3,5000,33.34f,10,0.050f,false,new Location.Location2D(1,35));		
		
		
			
		statsDsr.clear();

		
		// field
		if(options.circulaire)
		  bounds = new Location.Location2D(2*ray+10, 2*ray+10);			
		else
	      bounds = new Location.Location2D(sizeRw+1, 100);
		
		if(options.verbose)
			System.out.println("Bounds : "+bounds);
	      
	      field = new Field(bounds);	
		
		place= new jist.swans.runway.PlacementInterface[rw.length];
		for (int j=0;j<rw.length;j++){
		 if(options.filePosRw == null)
		   place[j]=new jist.swans.runway.Placement(rw[j]);
		 else
		   place[j]=new jist.swans.runway.PlacementFile(options.filePosRw); 
		 
		 rw[j].setCarsStats(statsRw);
		 rw[j].setNewCarEvent(self);
		 rw[j].setPlacement(place[j]);
		 rw[j].setField(field.getProxy());
	     rw[j].setNextId(100+j*1000);
	     rw[j].setCirculaire(options.circulaire);
		 statsRw.clear(rw[j]);
		 //rw[j].init();
		}
			 
				
		

	      //field.setMobility(rw[0]);
	      
	      radioInfoShared = RadioInfo.createShared(
	          Constants.FREQUENCY_DEFAULT, 
	          /*Constants.BANDWIDTH_DEFAULT*/options.optRadio.bandwidth,
	          /*Constants.TRANSMIT_DEFAULT*/options.optRadio.transmit, 
	          Constants.GAIN_DEFAULT,
	          /*Util.fromDB(Constants.SENSITIVITY_DEFAULT)*/options.optRadio.sensitivity_mW, 
	          /*Util.fromDB(Constants.THRESHOLD_DEFAULT)*/options.optRadio.threshold_mW,
	          Constants.TEMPERATURE_DEFAULT, 
	          Constants.TEMPERATURE_FACTOR_DEFAULT, 
	          Constants.AMBIENT_NOISE_DEFAULT);
	      
	      // protocol mapper
	      protMap = new Mapper(Constants.NET_PROTOCOL_MAX);
	      protMap.mapToNext(Constants.NET_PROTOCOL_DSR);
	      protMap.mapToNext(Constants.NET_PROTOCOL_UDP);
	      // packet loss
	      pl = new PacketLoss.Zero();		
	      
	      protocole=options.protocol;

	      
	      //udpEntity = new Hashtable();

	      
          JistAPI.endAt((options.timeSim)*Constants.SECOND);
          
	      JistAPI.runAt(new Runnable()
	      {
	        public void run()
	        {        	  
	        	System.err.print("Progress : "+ ((double)JistAPI.getTime()/ (double) ((options.timeSim)*Constants.SECOND))*100.0 + " % ("+JistAPI.getTime()+")"+"\r");
	        	
	        	JistAPI.runAt(this,(int)Constants.MILLI_SECOND*100 + JistAPI.getTime());
	        	
	        }
		}, (int)Constants.MILLI_SECOND*100 + JistAPI.getTime());	      
	      
	      
          if(options.verbose){	    
		      JistAPI.runAt(new Runnable()
		      {
		        public void run()
		        {
		        	
		        	  
		        	  System.err.println();
			          System.out.println(statsRw);
			          

			          System.out.println(statsDsr);
			          System.out.println("Overhead : "+(1.0-(double)statsDsr.send.dataSizePackets/(double)statsDsr.send.dsrSizePackets));

				          

			          System.out.println("Delai moyen : "+getStatDelayAvg()+"ms");
			          System.out.println("Delai max : "+getStatDelayMax()+"ms");	          
			          System.out.println("PDR : "+getStatPDR() + " " +getNbPacketReceived() +  "/" +  getNbPacketSend());
			          System.out.println("Throughput : "+getStatThroughput()+"bits/s");			          
			          System.out.println("Temps de simulation : "+ (System.currentTimeMillis() - timeStarted)/1000+"s");
		        }
		      }, JistAPI.END);   
	      
          }else{
		      JistAPI.runAt(new Runnable()
		      {
		        public void run()
		        {        	  
		        		  System.err.println();
			        	  System.out.println(options.name+" "+getStatDelayAvg()+" "+getStatDelayMax()+" "+getStatPDR() + " " + getStatThroughput() + " " + (1.0-(double)statsDsr.send.dataSizePackets/(double)statsDsr.send.dsrSizePackets) + " " + statsDsr.avgLength()+ " " + ((float)(System.currentTimeMillis() - timeStarted))/1000.0);
		        }
    		}, JistAPI.END);          	  
          }
          

	        	  

          int nbstep=(int)(((float)(options.timeSim))/options.precision);
          
          if(options.trafficstatic)
        	  nbstep=1;
	      //System.out.println(id-1);
          JRunWayWindow rwWin=null;
          
          if(options.gui)
        	  rwWin=new JRunWayWindow(rw,30.0f,3000.0f);
	      
	      for(int i=0;i<nbstep;i++){
	    	  
	    	    for (int j=0;j<rw.length;j++)
	    	    	rw[j].next();
	    	  	
	    	    if(rwWin!=null){
	    	    	rwWin.repaint();
	    	    }

	    	    
	    	    
	    	  	if(i==0){

	    	          Random rnd=new Random();
	    	          traficSources=new ArrayList(options.nbSource);
	    	          
    	        	  int idClient=50;
    	        	  int idServer=105;
	    	          
	    	          for(int j=0;j<options.nbSource;j++){
	    	        	  
	    	        	  boolean ok=true;
	    	        	  idClient=rnd.nextInt(rw[0].nbrCar()-1) + 100;
	    	        	  idServer=rnd.nextInt(rw[0].nbrCar()-1) + 100;
	    	        	  
	    	        	  //s.idClient = idClient++;
	    	        	  //s.idServer = idServer++;
	    	   
	    	        	  
	    	        	  //s.idClient = idClient;
	    	        	  //s.idServer = idServer;
	    	        	  if(idClient==idServer){
    	        			  j--;
    	        			  continue;	    	        		  
	    	        	  }
	    	        	  
	    	        	  for( Iterator it=traficSources.iterator() ; it.hasNext() ; ){
	    	        		  TraficSource t=(TraficSource)it.next();
	    	        		  if((t.idServer==idServer) || (t.idClient==idClient)){
	    	        			  j--;
	    	        			  ok=false;
	    	        			  break;
	    	        		  }
	    	        	  }
	    	        	  
	    	        	  if(ok){
	    	        		  TraficSource s=new TraficSource();
		    	        	  s.idClient = idClient;
		    	        	  s.idServer = idServer; 
	    	        		  traficSources.add(s);
	    	        	  }
	    	          }	 
	    	          
	    	          CreateBackBone();
	    	          
	    	          /*for(int j=0;j<options.nbSource;j++)
	    	        	  CreateNode(50+j, new Location.Location2D(1,1273));
*/
	    	  		
		    	  		/*int marge=(int)((options.speedTarget*options.timeSim)*1.5);
		    	  		RunWay runway=rw[options.doubleMind?1:0];

				    	 for (RunWayCar car=runway.beginEnumCar(0);car!=null;car=runway.enumCar(0, car)){
				    		 Location loc=runway.getCarLocation(car);
				    		 if(loc.getX()>(sizeRw-marge)){
				    			 idClient=car.id.intValue();
				    			 break;
				    		 }
				    	 }
				    	 
				    	 
				    		 
				    	 for (RunWayCar car=runway.beginEnumCar(0);car!=null;car=runway.enumCar(0, car)){
				    		 Location loc=runway.getCarLocation(car);
				    		 if(loc.getX()>(1000)){
				    			 server_id=car.id.intValue();
				    			 break;
				    		 }
				    	 }   */
	    	  		/*Random rnd=new Random();
	    	  		idClient= rnd.nextInt(rw[0].nbrCar()-1) + 100;
	    	  		server_id= rnd.nextInt(rw[0].nbrCar()-1) + 100;		   */ 	  	
	    	  	}
	    	  	
	    	  	
	    	  	//System.out.println(rw[0]);
	    	  	/*
	    	  	  if(i%5==0){
	    	  
		    	  	  place[0].reset();
				      while(addMobileNode(field, id,place[0],radioInfoShared,protMap,pl,pl,stats,udpEntity,rw[0],statsRw))
				    	  id++;
	    	  	  }
			      
			      rw[0].next(field);
			      
			      for(int j=0;j<rw[0].getNbrLan();j++){
			    	 for (RunWayCar car=rw[0].beginEnumCar(j);car!=null;car=rw[0].enumCar(j, car)){
			    		 if (car.id.intValue()==75)
			    			 System.out.println(car.loc);
			    	 }
			    		 
			      }
			      
			      RadioData rd=field.getRadioData(new Integer(75));
			      System.out.println(rd.getLocation());
			      
			      
			      System.out.println(jist.runtime.JistAPI.getTime()/Constants.MILLI_SECOND);
	      */
	      }
	      	      
	      
	      //addCBR(udpEntity,95);
	}
	
	

	
	  public static void main(String args[])
	  {
		try{  
	      final CommandLineOptions options = parseCommandLineOptions(args);
	      if(options.help) 
	      {
	        showUsage();
	        return;
	      }	
	      
	      if(options.verbose)
	      {
	    	 System.out.println(options); 
	      }
	      
	      
		  
		  hybridrunway_dhg sim= new hybridrunway_dhg();
		  sim.options= options;
	   //buildFieldTrio();
		  sim.buildFieldRunway();
		  
	    }
	    catch(CmdLineParser.OptionException e)
	    {
	      System.out.println(e.getMessage());
	    }
	  }	
}
//jist.swans.Main driver.hybridrunway_dhg -v  -T 5 -l 8000 -m -i 8 -a 8  -b 1 -r 8000 -k 512 -S -f /home/florent/these_bin/jist-swans-1.0.6/src/posvehic  -R 11:24.5:1.559e-8:3.652e-7