package driver;

import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import jist.runtime.JistAPI;
import jist.swans.Constants;
import jist.swans.misc.Util;
import jist.swans.misc.Mapper;
import jist.swans.misc.Location;
import jist.swans.field.Fading;
import jist.swans.field.Field;
import jist.swans.field.Mobility;
import jist.swans.field.PathLoss;
import jist.swans.field.Spatial;
import jist.swans.radio.RadioNoise;
import jist.swans.radio.RadioNoiseIndep;
import jist.swans.radio.RadioInfo;
import jist.swans.bus.BusEthernetSwitch;
import jist.swans.mac.MacAddress;
import jist.swans.mac.MacDumbBus;
import jist.swans.mac.MacDumb;
import jist.swans.net.NetAddress;
import jist.swans.net.NetIp;
import jist.swans.net.NetMultiInterface;
import jist.swans.net.PacketLoss;
import jist.swans.trans.TransUdp;
import jist.swans.app.AppJava;
import jist.swans.route.RouteDsr;

import java.net.InetAddress;


public class lantest {
	  public static final byte[] SERVER_IP = {0, 0, 0, 1};
	  public static final int PORT = 3001;

	  public static class Server
	  {
	    public static void main(String args[])
	    {
	      try
	      {
	        System.out.println("server starting at t="+JistAPI.getTime());
	        DatagramSocket socket = new DatagramSocket(PORT);
	        byte buf[] = new byte[256];
	        DatagramPacket packet = new DatagramPacket(buf, buf.length);
	        socket.receive(packet);
	        socket.close();
	        System.out.println("received at t="+JistAPI.getTime()+
	            " ("+packet.getLength()+" bytes) "
	            +(new String(packet.getData(), packet.getOffset(), packet.getLength())));
	      }
	      catch(Exception e)
	      {
	        e.printStackTrace();
	      }
	    }
	  }

	  public static class Client
	  {
	    public static void main(String args[])
	    {
	      try
	      {
	        System.out.println("client starting at t="+JistAPI.getTime());
	        DatagramSocket socket = new DatagramSocket();
	        byte[] buf = "hi".getBytes();
	        DatagramPacket packet = new DatagramPacket(
	          buf,
	          buf.length,
	          InetAddress.getByAddress(SERVER_IP),
	          PORT);

	        System.out.println("sent at t="+JistAPI.getTime());
	        System.out.flush();
	        socket.send(packet);
	        socket.close();
	      }
	      catch(Exception e)
	      {
	        e.printStackTrace();
	      }
	    }
	  }

	  private static void TwoNodeTest()
	  {
	   try
	    {
	      Mapper protMap = new Mapper(Constants.NET_PROTOCOL_MAX);
	      protMap.mapToNext(Constants.NET_PROTOCOL_DSR);
	      protMap.mapToNext(Constants.NET_PROTOCOL_UDP);
	      
	      // packet loss
	      PacketLoss pl = new PacketLoss.Zero();
	      
	      // mac
	      MacDumbBus mac1 = new MacDumbBus(new MacAddress(1),(int)100e6);
	      MacDumbBus mac2 = new MacDumbBus(new MacAddress(2),(int)100e6);
	      // net
	      NetIp net1 = new NetIp(new NetAddress(1), protMap, pl, pl);
	      NetIp net2 = new NetIp(new NetAddress(2), protMap, pl, pl);
	      
	      // route
	      RouteDsr dsr1 = new RouteDsr(net1.getAddress());
	      RouteDsr dsr2 = new RouteDsr(net2.getAddress());	      

	      TransUdp udp1 = new TransUdp();
	      TransUdp udp2 = new TransUdp();
	      
	      BusEthernetSwitch bus=new BusEthernetSwitch();
	      
	      bus.addMac(mac1.getProxy(), new MacAddress(1));
	      bus.addMac(mac2.getProxy(), new MacAddress(2));
	      
	      // net hookup
	      byte intId1 = net1.addInterface(mac1.getProxy());
	      byte intId2 = net2.addInterface(mac2.getProxy());
	      net1.setProtocolHandler(Constants.NET_PROTOCOL_DSR, dsr1.getProxy());
	      net2.setProtocolHandler(Constants.NET_PROTOCOL_DSR, dsr2.getProxy());
	      net1.setRouting(dsr1.getProxy());
	      net2.setRouting(dsr2.getProxy());
	      // route hookup
	      dsr1.setNetEntity(net1.getProxy());
	      dsr2.setNetEntity(net2.getProxy());	      
	      // mac hookup
	      mac1.setBusEntity(bus.getProxy());
	      mac2.setBusEntity(bus.getProxy());
	      mac1.setNetEntity(net1.getProxy(), intId1);
	      mac2.setNetEntity(net2.getProxy(), intId2);
	      // trans hookup
	      udp1.setNetEntity(net1.getProxy());
	      udp2.setNetEntity(net2.getProxy());
	      net1.setProtocolHandler(Constants.NET_PROTOCOL_UDP, udp1.getProxy());
	      net2.setProtocolHandler(Constants.NET_PROTOCOL_UDP, udp2.getProxy());

	      // applications
	      AppJava server = new AppJava(Server.class);
	      server.setUdpEntity(udp1.getProxy());
	      AppJava client = new AppJava(Client.class);
	      client.setUdpEntity(udp2.getProxy());

	      // run apps
	      server.getProxy().run(null); 
	      JistAPI.sleep(1);
	      client.getProxy().run(null);
	    }
	    catch(Exception e) { e.printStackTrace(); }
	  }
	  public static void main(String args[])
	  {
	    TwoNodeTest();
	  }
}
