package jist.swans.bus;

import jist.runtime.JistAPI;
import jist.runtime.JistAPI.Proxiable;
import jist.swans.field.Field.RadioData;
import jist.swans.misc.Message;
import jist.swans.radio.RadioInterface;
import jist.swans.mac.MacInterface;
import jist.swans.mac.MacAddress;
import jist.swans.mac.MacDumbBus.MacDumbMessage;

public class BusEthernetSwitch implements BusInterface {
	
	public static class MacData{
		protected MacInterface entity;
		protected MacAddress addr;
	}

	
	protected BusInterface self;
	protected MacData[] macs;
	/*protected boolean busy;	
	
	public boolean isBusy() {
		return busy;
	}

	public void setBusy(boolean busy) {
		this.busy = busy;
	}	*/
	public BusInterface getProxy() {
		return this.self;
	}	
	
	public BusEthernetSwitch(){
		this.self=(BusInterface)JistAPI.proxy(this, BusInterface.class);
		macs = new MacData[0];
	}
	
	  public void addMac(MacInterface entity,MacAddress addr){
		    if(!JistAPI.isEntity(entity)) throw new IllegalArgumentException("entity expected");
	  
		      MacData[] macs2 = new MacData[macs.length+1];
		      System.arraycopy(macs, 0, macs2, 0, macs.length);
		      
		      macs2[macs.length] = new MacData();
		      macs2[macs.length].entity=entity;
		      macs2[macs.length].addr=addr;		
		      
		      macs = macs2;
	  }

	  public void transmit(Message msg, long delay, long duration, MacAddress nextHop){
		    
		  	MacAddress src=null;
		  	
		  	if( msg instanceof MacDumbMessage)
		  		src = ((MacDumbMessage)msg).getSrc();
		  
		  	//System.out.println("Switch tranmit to " + nextHop);
		  	JistAPI.sleep(delay);
		    for(int i=0;i<macs.length;i++)
		    	if( ((src==null) || (src!=macs[i].addr)) && (nextHop.equals(MacAddress.ANY) || nextHop.equals(macs[i].addr)))
		    			macs[i].entity.receive(msg);
		    // schedule end of transmission
		    JistAPI.sleep(duration);
		    self.endTransmit();		  
	  }
	  public void endTransmit(){
		  
	  }

	  //////////////////////////////////////////////////
	  // communication (field)
	  //

	  public void receive(Message msg , Long duration){
		  
	  }
	  public void endReceive(){
		  
	  }




	  
}
