package jist.swans.net;

import org.apache.log4j.Logger;

import jist.runtime.JistAPI;
import jist.runtime.JistAPI.Continuation;
import jist.swans.mac.MacAddress;
import jist.swans.misc.Mapper;
import jist.swans.misc.Message;
import jist.swans.net.NetIp.NicInfo;
import jist.swans.net.NetMessage.Ip;
import jist.swans.route.RouteInterface;

public class NetMultiInterface implements NetInterface {
	  /**
	   * IP logger.
	   */
	  public static final Logger log = Logger.getLogger(NetIp.class.getName());

    /** network interfaces. */
    protected NetInterface[] nics;	
    //protected RouteInterface routing;
    
    /** self-referencing proxy entity. */
    protected NetInterface self;
    
    public NetMultiInterface()
    {
      // proxy entity
      this.self = (NetInterface)JistAPI.proxy(this, NetInterface.class);
      this.nics = new NetInterface[0];
    }
	
	public void addNetIp(NetInterface netEntity){
		
		NetInterface[] nics2 = new NetInterface[nics.length+1];
		//netEntity.setRouting(routing);
	    System.arraycopy(nics, 0, nics2, 0, nics.length);
	    nics2[nics.length] = netEntity;
	    nics = nics2;

		
	}	
	

/*	  public void setRouting(RouteInterface routingEntity)
	  {
	    if(!JistAPI.isEntity(routingEntity)) throw new IllegalArgumentException("expected entity");
	    this.routing = routingEntity;
	    
		for (int i=0;i<nics.length;i++)
			nics[i].setRouting(routing);	    
	  }	*/
	
	public NetAddress getAddress() throws Continuation {
		// TODO Auto-generated method stub
		if(nics.length>0)
			return nics[0].getAddress();
		return null;
	}

	  //////////////////////////////////////////////////
	  // entity hookup
	  //

	  /**
	   * Return self-referencing proxy entity.
	   *
	   * @return self-referencing proxy entity
	   */
	  public NetInterface getProxy()
	  {
	    return this.self;
	  }	
	
	public void pump(int netid) {
		// TODO Auto-generated method stub
		System.out.println("Pump call");		

	}

	public void receive(Message msg, MacAddress lastHop, byte macId,
			boolean promiscuous) {
		// TODO Auto-generated method stub
		System.out.println("Receive call");
	}

	public void send(Message msg, NetAddress dst, short protocol,
			byte priority, byte ttl) {
		// TODO Auto-generated method stub
		for (int i=0;i<nics.length;i++)
			nics[i].send(msg,dst,protocol,priority,ttl);
	}

	public void send(Ip msg, int interfaceId, MacAddress nextHop) {
		// TODO Auto-generated method stub
			//vien du ad-hoc
		for (int i=0;i<nics.length;i++)
			nics[i].send(msg, interfaceId, nextHop);
	}

}
