package jist.swans.runway;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferStrategy;
import javax.swing.*;

public class JRunWayWindow extends JFrame {

	static public class JPanelRW extends JPanel
	{
	     private RunWay rw[];
	     private float echelle,pos;
	     
	     public JPanelRW(RunWay rw[],float echelle,float pos){
	    	 this.echelle=echelle;
	    	 this.rw=rw;    	 
	    	 this.pos=pos;
	     }
	     
	     public Color nextColor(int i){
	    	 
	    	 switch(i%10){
	    	 case 0:
	    		 return Color.GREEN;	    		 
	    	 case 1:
	    		 return Color.ORANGE;
	    	 case 2:
	    		 return Color.RED;
	    	 case 3:
	    		 return Color.BLACK;
	    	 case 4:
	    		 return Color.GRAY;
	    	 case 5:
	    		 return Color.MAGENTA;
	    	 case 6:
	    		 return Color.BLUE;
	    	 case 7:
	    		 return Color.PINK;
	    	 case 8:
	    		 return Color.CYAN;
	    	 case 9:
	    		 return Color.YELLOW;
	    		 
	    		 
	    	 }
	    	 
	    	 return Color.YELLOW;
	     }
	     
			public void drawRW(Graphics g,RunWay rw) {
				Color c = g.getColor();
				
				
				
				g.setColor(Color.BLACK);
				g.drawRect((int)((rw.getPos().getX()-pos)*echelle), (int)(rw.getPos().getY()*echelle), (int)(rw.rwSize*echelle), (int)((rw.getLaneSize()*rw.getNbrLan())*echelle));
				
				
				for (int i=0;i<rw.getNbrLan();i++){
					/*if(i==0)
						g.setStroke(new BasicStroke(5.0f));
					else*/
					g.setColor(Color.WHITE);
					if(i>0)
						g.drawLine((int)((rw.getPos().getX()-pos)*echelle), (int)(((i)*rw.getLaneSize()+rw.getPos().getY())*echelle), (int)(rw.rwSize*echelle), (int)(((i)*rw.getLaneSize()+rw.getPos().getY())*echelle));
				
				
					for (RunWayCar car=rw.beginEnumCar(i);car!=null;car=car.next){
						
						//g.setColor(nextColor(cars[i].id.intValue()));		
						
						int l=(int)(echelle*1.5)+1;
						g.setColor(nextColor(car.regime));
						g.fillRect((int)((rw.getCarLocation(car).getX()-car.length-pos)*echelle),(int)(rw.getCarLocation(car).getY()*echelle)-l/2,(int)(echelle*car.length)+1,l);
						
						//System.out.println((int)((cars[i].loc-pos)*echelle)+10+" "+(int)((cars[i].lane*rw.getLaneSize()+(rw.getLaneSize()/2.0f))*echelle/*10.0*/)+40+" "+(int)(echelle*cars[i].length)+1+" "+(int)(echelle*1.5)+1);
						
						//System.out.print(car.id+" " + rw.getCarLocation(car) );
					}				
				
				}
				


				//System.out.println();
				
				g.setColor(c);
			}
			
			public void paint(Graphics g){
				for (int i=0;i<rw.length;i++)
					drawRW(g,rw[i]);				
				//super.paint(g);
			}		
	}




	
	
	
	 public JRunWayWindow(RunWay[] rw,float zoom,float pos){


	    

	     
	     float echelle=1200.0f/rw[0].getRwSize();
	     echelle*=zoom;

	     
	     JPanelRW jp = new JPanelRW(rw,echelle,pos);
	     
	     
	     

	    
	     addWindowListener(new WindowAdapter(){
	         public void windowClosing(WindowEvent e){
	             System.exit(0);	//An Exit Listener
	         }
	     });
	    

	    
		 getContentPane().add(jp);
		 pack();
	     setBounds(60,60,1220,300);   
	     
	     setVisible(true);
	 }	
	
}


