/**
 * 
 * Réprésente une autoroute : ensemble de fils de véhicules
 * 
 * @author Florent Kaisser
 */

/*
 * 
 * Question existentiel : 
 * - peut on faire évoluer le simulateur en prenant en consideration les voiture independament
 * - A quoi sert p->change ?
 * - La mtéhode polaire est plus rapide pour la génération d'un nombre aléatoire suivant la loi normal
 * - cas quand on à pas de next et le voiture est arreté -> segmentation fault
 * - calcul de diffV et diffX identique au début de acceleration ?
 * - si h==6 dans acceleration ??
 * - dans laneChange , le calcul de u et goodCond est toujours le meme ?
 * - pourquoi la nouvelle vitesse est multiplié par 0.5 ?
 * - unité de l'intensité ? pourquoi on mutipli par 1000 lors du tirage de l'écart
 * - actualisation de la vitesse
 * - tailgate
 */

package jist.swans.runway;

import org.apache.log4j.Logger;

import driver.MyCBR;
import jist.minisim.sleepblock;
import jist.runtime.JistAPI;
import jist.swans.field.FieldInterface;
import jist.swans.field.Field;
import jist.swans.field.Mobility;
import jist.swans.misc.Location;
import jist.swans.runway.RunWayCar.RunWayCarStats;

public class RunWay {
	
	/**
	 * gère une file
	 */
	public class Lane{
		//private static int nextId=0;
		private int id;
		private int nbCar;
		private RunWayCar firstCar;
		private RunWayCar lastCar;
		//private float gapsCar;
		
		public Lane(int id){
			this.id=id;
			this.firstCar=null;
			this.lastCar=null;
			//this.gapsCar=-1.0f;
			nbCar=0;

		}
		
		/**
		 * ajoute un véhicule au début de la file
		 * @param c Le véhicule à ajouter
		 */
		public void addCar(RunWayCar c){
			if(firstCar==null)
				lastCar=c;

			c.next=firstCar;
			if(firstCar!=null)
				firstCar.prev=c;
			
			firstCar=c;
			
			nbCar++;
		}
		
		/**
		 * Ajoute un véhicule à la fil avant un véhicule particulier
		 * @param newCar véhicule à ajouter
		 * @param nextCar véhicule qui sera devant le nouveau véhicule
		 */
		public void insertCar(RunWayCar newCar,RunWayCar nextCar){

			newCar.next=nextCar;
			
			if(nextCar==null){
				newCar.prev=lastCar;
			}else{
				newCar.prev=nextCar.prev;
				nextCar.prev=newCar;
			}
				
				if(newCar.prev!=null)
					newCar.prev.next=newCar;
			
			
			
			nbCar++;
		}	
		
		/**
		 * insert un véhicule à son bonne emplacement 
		 * en fonction de son emplacement sur son ancienne fil
		 * @param newCar véhicule à ajouter
		 */
		public void insertCar(RunWayCar newCar){
			RunWayCar nextCar;
			
			for ( nextCar=firstCar;nextCar.next!=null;nextCar=nextCar.next)
				if (nextCar.loc>=newCar.loc)
					break;
			
			insertCar(newCar,nextCar);
		}
		
		public void delCar(RunWayCar c){
			if(c.prev!=null) c.prev.next = c.next;
			if(c.next!=null) c.next.prev = c.prev;
			if(firstCar==c) firstCar = c.next;
			if(lastCar==c) lastCar = c.prev;
			/*firstCar.next = null;
			firstCar.prev = null;	*/		
			nbCar--;
		}
		
		public String toString(){
			
			String s=  nbCar +" [";
			
			for(RunWayCar car=firstCar;car!=null;car=car.next){
				s+=car;
				s+=" ";
			}
			
			s+="]";
			
			return s;
		}
	
		
	}
	
	protected Lane[] lanes; //lanes
	protected float laneSize; //largeur d'une voie
	protected float rwSize; //longueur de l'autoroute 
	protected float avgTargetSpeed;
	protected float intensity;
	protected float precision; //temps de pause en seconde
	protected RunWayCarStats stats;//statistique des voitures
	
	protected boolean sens; //sens de ciculation des véhicule
	protected Location pos; //position de l'autoroute
	
	protected NewCarEventInterface newCarEventInterface;
	protected PlacementInterface placement;
	protected FieldInterface field;
	protected int nextId=0;
	protected boolean circulaire=false; //autoroute circulaire (bouclé, déconseillé pour les passagés malade en voiture )
	private float rayLan[];
	
	public Random rand=new Random();
	
	private int step=0;

	
  /** RunWay logger. */
  private static Logger log = Logger.getLogger(RunWay.class.getName());  



	public RunWay(int nbrLane, float laneSize,float rwSize, float avgTargetSpeed,float intensity,float precision,boolean sens,Location.Location2D loc) {
		this.avgTargetSpeed=avgTargetSpeed;
		this.lanes=new Lane[nbrLane];
		this.intensity=intensity;
		this.rwSize=rwSize;
		this.precision=precision;
		this.sens=sens;
		pos=loc;
		
		for(int i=0;i<nbrLane;i++){
			this.lanes[i]=new Lane(i);
		}
		
		this.laneSize=laneSize;
		
		
	}
	
	public void init(){
		for(int i=0;i<10000;i++){
			next(0);
		}
	}
	
	public RunWayCar initCar(Integer id, Location loc,RunWayCarStats stats){
		//Location relloc=calcLocationInv((Location.Location2D)loc);
		RunWayCar car = new RunWayCar(id,this,(int)loc.getY(),loc.getX());
		
		if(stats==null)
			stats=this.stats;
		
		car.setStats(stats);
		lanes[car.lane].addCar(car);
		
		return car;		
		
	}	
	
	public RunWayCar initCar(Integer id, Location loc){
		return initCar(id,loc,null);		
	}

	/*public MobilityInfo init(FieldInterface f, Integer id, Location loc) {
		return (MobilityInfo)init(id,loc,null);
	}*/
	

	/*public void next(FieldInterface f, Integer id, Location loc,
			MobilityInfo info) {
		


		RunWayCar car = (RunWayCar)info;
		//float x=car.loc;
		
		//System.out.println("move");
		
		System.out.println("move "+car.loc+" "+id+" "+jist.runtime.JistAPI.getTime());		
		
		//on avance le véhicule
		car.nextStep();
		
		

		
		//si on peut supprimer et que le véhicule est sorti de l'autoroute
		if(car.loc>rwSize){
			System.out.println("suppression de "+car.id);
			//on supprime le véhicule (haaa, non au secours !!)
			lanes[car.lane].delCar(car);
			
			//on supprime le noeud du réseau
			f.delRadio(id);
			
			//pas la peine d'aller plus loins
			return;
		}
	

		
		//on déplace le noeud
//		transformation loc
        //f.moveRadio(id, getCarLocation(car) );
		f.moveRadioOneTime(id,getCarLocation(car));
   
	}*/
	
	/*public void next() {

		for(int i=lanes.length-1;i>=0;i--){
		//for(int i=0;i<lanes.length;i++){	
			for(RunWayCar car=lanes[i].lastCar;car!=null;car=car.prev){
			//for(RunWayCar car=lanes[i].firstCar;car!=null;car=car.next){
				//on avance le véhicule
				car.nextStep();
				
				
				//si  le véhicule est sorti de l'autoroute
				if(car.loc>rwSize)
					//on supprime le véhicule (haaa, non au secours !!)
					lanes[car.lane].delCar(car);
			}
		}
			

	

	}	*/
	
	public void next(){
		next((int)(precision* ((float)jist.swans.Constants.SECOND)));
	}
	
	public void next(long timeSleep){

		
		for(int i=lanes.length-1;i>=0;i--){
			
				for(RunWayCar car=lanes[i].lastCar;car!=null;car=car.prev){
					//System.out.println("move "+car.loc+" "+car.id+" "+jist.runtime.JistAPI.getTime());	
					//on avance le véhicule
					car.nextStep();
					
					//si on peut supprimer et que le véhicule est sorti de l'autoroute
					if( (!circulaire) &&  car.loc>rwSize){
						
						//System.out.println("suppression de "+car.id);
						
						//on supprime le véhicule (haaa, non au secours !!)
						lanes[car.lane].delCar(car);
						
						if(field!=null){
							newCarEventInterface.deleteCarEvent(car.id.intValue());
							//on supprime le noeud du réseau
							field.delRadio(car.id);
						}
						

					}else if(field!=null){
						field.moveRadio(car.id,getCarLocation(car));		
					}
				}
		}
		
		//si c'est ciruclaire, on ajoute qu'au début
		//on ajoute tous les 5 étapes
		if( (!circulaire || step==0) && placement!=null && step%5==0){
			Location newloc;
			placement.reset();
			
			//System.out.println("ajout de véhicules : ");
			
			while ( (newloc=  placement.getNextLocation()) !=null ){
				initCar(new Integer(nextId),newloc);
				if(newCarEventInterface!=null)
					newCarEventInterface.newCarEvent(nextId,calcLocation(newloc.getX(), (int) newloc.getY()));
				//System.out.println(nextId+" "+(int)newloc.getY()+"\t"+newloc.getX());
				nextId++;
				//System.out.println("ajout d'un véhicule ");
			}
			
			
		}
		
		if(timeSleep>0)
			//on avance le temps (c'est magique (-;
			JistAPI.sleep(timeSleep);
		
		
		step++;
	}
	
//next(Field field)
	
	public void changeLane(RunWayCar car,int oldLane,int newLane){
		lanes[oldLane].delCar(car);
		lanes[newLane].insertCar(car);		
	}

	
	/**
	 * retourne le leader de droite par rapport à la voiture car qui est sur lane
	 * @param lane voie
	 * @param car voiture
	 * @return le leader
	 */
	protected RunWayCar getLeadR(int lane,RunWayCar car){
		lane++; //lane à droite
		if (lane>=lanes.length)
			//pas de voie à droite
			return null;
		
		return getLead(lane,car);
	}

	/**
	 * retourne le leader de gauche par rapport à la voiture car qui est sur lane
	 * @param lane voie
	 * @param car voiture
	 * @return le leader
	 */
	protected RunWayCar getLeadL(int lane,RunWayCar car){
		lane--; //lane à gauche
		if (lane<0)
			//pas de voie à gauce
			return null;
		
		return getLead(lane,car);		
	}
	
	/**
	 * retourne le leader sur la voie lane par rapport à la voiture car
	 * @param lane voie
	 * @param car voiture
	 * @return le leader
	 */
	protected RunWayCar getLead(int lane,RunWayCar car){
		
		if (lanes[lane].firstCar==null)
			return null;
		
		for (RunWayCar lead=lanes[lane].firstCar;lead.next!=null;lead=lead.next)
			if (lead.loc>=car.loc)
				return lead;
		return null;
	}

	/*public RunWayCar[] getCars(){
		
		RunWayCar cars[]=new RunWayCar[nbrCar()];
		int id=0;
		
		for(int i=lanes.length-1;i>=0;i--){
			
			for(RunWayCar car=lanes[i].lastCar;car!=null;car=car.prev){

				cars[id++]=car;

			}
		}		
		return cars;
		
	}	*/
	
	public RunWayCar beginEnumCar(int lane){
		return lanes[lane].firstCar;
	}
	
	public RunWayCar enumCar(int lane,RunWayCar prevCar){
		return prevCar.next;
	}
	
	public Location calcLocation(float loc,int lane){
		float x,y;
		/*if(sens){
			x= rwSize - loc+pos.getX();
			y=((lanes.length-lane-1)+0.5f)*laneSize+pos.getY();		
		}else{
			x=loc+pos.getX();
			y=(lane+0.5f)*laneSize+pos.getY();					
		}	*/
	
		if(sens){
			loc = rwSize - loc;
			lane = lanes.length-lane-1;
		}		
		
		if(circulaire){
			x = rayLan[lane]*(float)Math.cos(loc/rayLan[lane]) + pos.getX();
			y = rayLan[lane]*(float)Math.sin(loc/rayLan[lane]) + pos.getX();
		}else{
			x=loc+pos.getX();
			y=(lane+0.5f)*laneSize+pos.getY();							
		}
			
		
		return new Location.Location2D(x,y);
	}
	
	
	/*public Location calcLocationInv(Location.Location2D location){
		float loc;
		int lane;
		float x=location.getX();
		float y=location.getY();
		if(sens){
			loc= rwSize+pos.getX()-x;
			lane=(int)(((pos.getY()-y)/laneSize)+0.5f+lanes.length-1);
		}else{
			loc=x-pos.getX();
			lane=(int)(((y-pos.getY())/laneSize)-0.5f);				
		}	
		
		return new Location.Location2D(loc,(float)lane);
	}	*/
	
	public Location getCarLocation(RunWayCar car){
		return calcLocation(car.loc,car.lane);
	}
	
	public int nbrCar(){
		int nb=0;
		for(int i=0;i<lanes.length;i++)
			nb+=lanes[i].nbCar;
		return nb;
	}	
	
	public float getPrecision() {
		return precision;
	}	
	public float getIntensity() {
		return intensity;
	}

	public int getNbrLan() {
		return lanes.length;
	}

	public float getLaneSize() {
		return laneSize;
	}
	
	public float getAvgTargetSpeed() {
		return avgTargetSpeed;
	}	
	
	public RunWayCar getFirstCar(int lane) {
		return lanes[lane].firstCar;
	}

	public float getRwSize() {
		return rwSize;
	}

	public void setAvgTargetSpeed(float avgTargetSpeed) {
		this.avgTargetSpeed = avgTargetSpeed;
	}	
	
	public void setCarsStats(RunWayCarStats stats){
		this.stats=stats;
	}
	
	public String toString(){
		
		String s="";
		
		for(int i=0;i<lanes.length;i++){
				s+=lanes[i];
				s+="\n";
		}
		
		return s;
	}



	public Location getPos() {
		return pos;
	}

	public void setNewCarEvent(NewCarEventInterface newCarEventInterface) {
		this.newCarEventInterface = newCarEventInterface;
	}

	public void setPlacement(PlacementInterface placement) {
		this.placement = placement;
	}

	public void setField(FieldInterface field) {
		this.field = field;
	}
	public int getNextId() {
		return nextId;
	}

	public void setNextId(int nextId) {
		this.nextId = nextId;
	}

	public boolean isCirculaire() {
		return circulaire;
	}

	public void setCirculaire(boolean circulaire) {
		this.circulaire = circulaire;
		if(circulaire){
			
			pos=new Location.Location2D((rwSize/(float)(2.0*Math.PI)),pos.getY());
			
			
			rayLan=new float[lanes.length];
			
			for (int i=0;i<lanes.length;i++)
				rayLan[i]=(rwSize/(float)(2.0*Math.PI))- (float)((i*laneSize)+pos.getY()) ;
		}
	}	
}


