package jist.swans.runway.graph;
import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Set;

import edu.uci.ics.jung.graph.Edge;
import edu.uci.ics.jung.graph.Vertex;

public class Cluster extends HashSet<CarVertex>{
	float stat_lifetime=0.0f;
	boolean broken=false;
	
    public boolean connected()
    {

        if (size() == 0)
            return true;
        
        Vertex start = iterator().next(); // pick any vertex
        Set visited = new HashSet();
        LinkedList stack = new LinkedList();
        stack.add(start);
        // traverse through graph in depth-first order
        while (!stack.isEmpty())
        {
            Vertex v = (Vertex)stack.removeFirst();
            visited.add(v);
            Set neighbors = v.getNeighbors();
            
            for (Iterator n_it = neighbors.iterator(); n_it.hasNext(); )
            {
                Vertex w = (Vertex)n_it.next();
                
//              on prend seulement les voisins contenu dans le cluster et pas encore visité
                if (contains(w) && !visited.contains(w))
                    stack.addFirst(w);
            }
        }
        return (visited.size() == size());
    }	
	
	  public float lengthCluster(Collection<CarVertex> v){
		  float minpos=Float.MAX_VALUE,maxpos=0.0f;
		  
		  for (Iterator<CarVertex> i=v.iterator();i.hasNext();){
			  CarVertex car=i.next();
			  
			  if(car.getLoc()<minpos)minpos=car.getLoc();
			  if(car.getLoc()>maxpos)maxpos=car.getLoc();			  
			  
		  }
		  
		  return maxpos-minpos;
	  }	
	  public  Collection<Edge> getEdgesInCluster(){
		  LinkedList<Edge> l= new LinkedList<Edge>();
		  
		  Iterator<CarVertex> i=iterator();
		  while(i.hasNext()){
			  Vertex src=i.next();
			  Set<Edge> edges = src.getOutEdges();
			  
			  Iterator<Edge> j=edges.iterator();
			  while(j.hasNext()){
				  Edge e=j.next();
				  
				  if(contains(e.getEndpoints().getSecond()) )
					  l.add(e);
			  }

		  }
		  
		  return l;
	  }	
	  
	public void processStat(float t){
		if(!broken && connected())
			stat_lifetime=t;
		else
			broken=true;
	}
	  
	/*public String edgeStat(double maxLifeTime){
		
		  Collection<Edge> edges=getEdgesInCluster(this);
		  
		  //System.out.println(edges);
		  
		  EdgeStat stat= new EdgeStat(edges);
		  stat.setLifeTimeBoundary(maxLifeTime, Double.MAX_VALUE);
		  stat.computeStat();		
		
		  return stat.getStats().toString();
	}
	
	public String edgeStat(){
		return edgeStat(0.0);
	}
	*/
	public String stat(){
		return size()+" " +stat_lifetime+ " "+(broken ? 0 : 1);
	}
	
	Cluster(){
		super();
	}
}
