package jist.swans.runway.graph;

import edu.uci.ics.jung.graph.Edge;
import edu.uci.ics.jung.graph.filters.EfficientFilter;
import edu.uci.ics.jung.graph.filters.GeneralEdgeAcceptFilter;

public class LifeTimeFilter extends GeneralEdgeAcceptFilter implements
		EfficientFilter {
	private float minLifeTime;
	
	public LifeTimeFilter(float minLifeTime){
		this.minLifeTime=minLifeTime;
	}
	
	
	public boolean acceptEdge(Edge e) {
		CarVertex v1=(CarVertex)e.getEndpoints().getFirst();
		CarVertex v2=(CarVertex)e.getEndpoints().getSecond();
		float lf=EdgeStat.lifeTime(v1,v2);
		//System.out.println(lf);
		return lf >= minLifeTime;
	}

	public String getName() {
		
		return "LifeTime filter for highway graph";
	}

}
