import sys,getopt
import re
import math

def somme(liste):
	s=0.0
	s_carre=0.0;
	for n in liste:
		s+=n
		s_carre+=(n*n)
	return s,s_carre
	
def moyenne(liste):
	return somme(liste)[0]/len(liste)
	
def variance(liste):
	s=somme(liste)
	return math.sqrt( (s[1]/len(liste)) - (moyenne(liste)*moyenne(liste))  )	

def interConf(liste):
	if(len(liste)>1):
		return 1.96*variance(liste)/(math.sqrt(len(liste) - 1))	
	return 0.0

stat_line = re.compile(r'(?P<name>\b\w+\b) (?P<delay>[0-9.]+) (?P<delay_max>[0-9.]+) (?P<PDR>[0-9.]+) (?P<throughput>[0-9.]+) (?P<overhead>[0-9.]+) (?P<longueur>[0-9.]+) (?P<duree>[0-9.]+)')

n=0
verbose=False
delay=[]
delay_max=[]
pdr=[]
throughput=[]
overhead=[]	
longueur=[]
duree=[]	
name=""

try:
	opts, args = getopt.getopt(sys.argv[1:], "v", ["verbose"])
except getopt.GetoptError:
        # print help information and exit:
	sys.exit(2)

for o in opts:
	if "-v" in o:
		verbose = True

if len(args)==0 :
	f=iter(sys.stdin.readline, '')
else:
	f=open(args[0])
	
for line in f:
	g=stat_line.search(line)

	if g:
		name=str(g.group('name'))
		delay.append(float(g.group('delay')))
		delay_max.append(float(g.group('delay_max')))
		pdr.append(float(g.group('PDR')))
		throughput.append(float(g.group('throughput')))		
		overhead.append(float(g.group('overhead')))
		longueur.append(float(g.group('longueur')))	
		duree.append(float(g.group('duree')))			

	
if verbose :
	#print "delay :",delay,"delay_max :",delay_max,"pdr :",pdr,"overhead :",overhead,"longueur :",longueur
	print "---------------------------------"
	print name
	print "---------------------------------"
	print "delay :",moyenne(delay),[interConf(delay)]
	print "delay_max :",max(delay_max)
	print "pdr :",moyenne(pdr),[interConf(pdr)]
	print "throughput :",moyenne(throughput),[interConf(throughput)]
	print "overhead :",moyenne(overhead),[interConf(overhead)]
	print "longueur :",moyenne(longueur),[interConf(longueur)]
	print "duree de simulation :",moyenne(duree),[interConf(duree)]
else:
	print name,moyenne(delay),interConf(delay),max(delay_max),moyenne(pdr),interConf(pdr),moyenne(throughput),interConf(throughput),moyenne(overhead),interConf(overhead),moyenne(longueur),interConf(longueur),moyenne(duree),interConf(duree)
	



