/**
 * Extension de la classe Random de Java API pour la loi normal
 * et la loi exponentiel
 * @author Florent Kaisser
 */

package jist.swans.runway;


public class Random extends java.util.Random{
	
	public double nextNormal(double m, double sigma)
	{
        double x1, x2,w;
        
        
        
		do {
		        x1 = 2.0 * nextDouble() - 1.0;
		        x2 = 2.0 * nextDouble() - 1.0;
		        w = x1 * x1 + x2 * x2;
		} while ( w >= 1.0 );
		
		return(m+sigma*x1*Math.sqrt( (-2.0 * Math.log( w ) ) / w ));	
	}

	
	double nextExponentiel(double mu)
	{
	        double u;
	        
			do {
				u=nextDouble();
			} while ( u<=0.0 );
	        
	        return   (-Math.log(u)/mu);

	}
	     

	  public static void main(String args[])
	  {
		  Random r=new Random();
		  for(int i=0;i<1000;i++){
			  System.out.println(r.nextNormal(120,0.05*120));	
			  //System.out.println(r.nextExponentiel(2.54));
		  }
		  
	  }

}
